# Effects utilities

Contains utility functions extending the functionality of the `eff` package.

```idris
module Util.Eff

import Control.Eff
import Text.ANSI

%default total
```

## Logging

Use the `WriterL "log" String` effect like a logging library. We'll provide a few "log levels" as verbs for the effect, but no filtering is done, when logging is enabled, all logs are always displayed, however the log level is indicated with a colored tag. 

<!-- idris
namespace Logging
-->
```idris
  export
  info : Has (WriterL "log" String) fs => Lazy String -> Eff fs ()
  info str =
    let tag = show . bolden . show . colored Green $ "[INFO]"
    in tellAt "log" (tag ++ ": " ++ str ++ "\n")

  export
  debug : Has (WriterL "log" String) fs => Lazy String -> Eff fs ()
  debug str =
    let tag = show . bolden . show . colored BrightWhite $ "[DEBUG]"
    in tellAt "log" (tag ++ ": " ++ str ++ "\n")

  export
  warn : Has (WriterL "log" String) fs => Lazy String -> Eff fs ()
  warn str =
    let tag = show . bolden . show . colored Yellow $ "[WARN]"
    in tellAt "log" (tag ++ ": " ++ str ++ "\n")
```
